package utils;

import model.Cell;

public class CellUtils {
	protected static int changeReverse(int cell) {
		if (cell == Cell.HIDARI) {
			return Cell.MIGI;
		} else if (cell == Cell.MIGI) {
			return Cell.HIDARI;
		} else {
			return cell;
		}
	}

	public static int changeRotate(int cell) {
		switch (cell) {
		case Cell.MIGI:
			return Cell.SHITA;
		case Cell.YOKO:
			return Cell.TATE;
		case Cell.HIDARI:
			return Cell.UE;
		case Cell.UE:
			return Cell.MIGI;
		case Cell.TATE:
			return Cell.YOKO;
		case Cell.SHITA:
			return Cell.HIDARI;
		default:
			return cell;
		}
	}

	public static void setNumber(Cell cell, int i) {
		if (cell.compareTo(0) >= 0) { // }XȂꍇA킪
			if (i == 0) {
				cell.setNumber(Cell.ZERO);
			} else {
				cell.setNumber(-i);
			}
		} else { // }X̏ꍇA2P^
			cell.multiply(10);
			cell.remainder(100);
			cell.subtract(i);
		}
	}

	public static void setBamboo(Cell cell, String s) {
		if (s == "left") {
			cell.setNumber(Cell.HIDARI);
		} else if (s == "horizontal") {
			cell.setNumber(Cell.YOKO);
		} else if (s == "right") {
			cell.setNumber(Cell.MIGI);
		} else if (s == "up") {
			cell.setNumber(Cell.UE);
		} else if (s == "vertical") {
			cell.setNumber(Cell.TATE);
		} else if (s == "down") {
			cell.setNumber(Cell.SHITA);
		}
	}

	/** bNԂ̂Ƃ̓ */
	public static void setBambooLocked(Cell cell, String string) {
		if (cell.isNumber())
			return;
		setBamboo(cell, string);
	}

	public static void swap(Cell cell, Cell cell2) {
		int number = cell.getNumber();
		cell.setNumber(changeReverse(cell2.getNumber()));
		cell2.setNumber(changeReverse(number));
	}

	public static boolean isIsland(Cell cell) {
		return cell.compareTo(Cell.SHIMA) == 0;
	}

	public static void makeIsland(Cell cell) {
		cell.setNumber(Cell.SHIMA);
	}

	public static void setCross(Cell cell) {
		cell.setNumber(Cell.BATSU);
	}

	public static void makeIslandLocked(Cell cell) {
		if (cell.isNumber())
			return;
		makeIsland(cell);
	}

	public static void setCrossLocked(Cell cell) {
		if (cell.isNumber())
			return;
		setCross(cell);
	}

	/** 𓚃[h̓ */
	public static void setValueLocked(Cell cell, int masu) {
		if(!cell.isNumber()){
			cell.setNumber(masu);
		}
	}

}
